[Treepkg-commits] r327 - trunk/recipes/kde/enterprise

scm-commit@wald.intevation.org scm-commit at wald.intevation.org
Tue Jun 15 12:56:44 CEST 2010


Author: bricks
Date: 2010-06-15 12:56:44 +0200 (Tue, 15 Jun 2010)
New Revision: 327

Added:
   trunk/recipes/kde/enterprise/kde_l10n.py
   trunk/recipes/kde/enterprise/kde_l10n_tags.py
Log:
added kde_l10n packager that builds only tags


Copied: trunk/recipes/kde/enterprise/kde_l10n.py (from rev 326, trunk/recipes/kde/enterprise/branch_4/kde_l10n.py)

Copied: trunk/recipes/kde/enterprise/kde_l10n_tags.py (from rev 326, trunk/recipes/kde/enterprise/branch_4/kde_l10n.py)
===================================================================
--- trunk/recipes/kde/enterprise/branch_4/kde_l10n.py	2010-06-01 17:36:32 UTC (rev 326)
+++ trunk/recipes/kde/enterprise/kde_l10n_tags.py	2010-06-15 10:56:44 UTC (rev 327)
@@ -0,0 +1,102 @@
+# Copyright (C) 2007, 2008, 2009 by Intevation GmbH
+# Authors:
+# Bernhard Herzog <bh at intevation.de>
+#
+# This program is free software under the GPL (>=v2)
+# Read the file COPYING coming with the software for details.
+
+import os
+import logging
+import shutil
+import time
+
+import treepkg.util
+
+import recipes.kde.enterprise.tags as tags
+
+
+class SourcePackager(tags.SourcePackager):
+
+    """Creates the debian source package for the l10n files
+
+    This is a bit more complicated than for other packages.  The
+    orig.tar.gz file of the debian source package contains one .tar.bz2
+    file for every language.  Those .tar.bz files are the kde-18n-<lang>
+    files released by the KDE project.  For now, we only have the German
+    localization in the enterprise source package, so the orig.tar.gz
+    file will have the following contents:
+
+      kde-l10n-<version>/
+      kde-l10n-<version>/kde-l10n-de-<version>.tar.bz2
+
+    <version> is the same everywhere.
+    """
+
+    createtarball_script = """\
+#! /bin/bash
+set -e
+
+apt-get --assume-yes --force-yes install %(builddeps)s
+
+# copy the source tree to a directory that's under pbuilder control so
+# that it gets removed along with the build environment.  Otherwise we
+# end up with a directory containing files that cannot be removed by
+# treepkg
+workdir=/tmp/work
+cp -a %(basedir)s $workdir
+cd $workdir
+
+# only handle the de subdirectory
+echo de > subdirs
+
+# create the CMakeFiles
+./scripts/autogen.sh
+mv de kde-l10n-de-%(version)s
+tar cjf %(tarball)s kde-l10n-de-%(version)s
+"""
+
+
+    def __init__(self, *args, **kw):
+        super(SourcePackager, self).__init__(*args, **kw)
+        self.enterprise_version = (time.strftime("%Y%m%d", time.localtime())
+                                   + "." + str(self.revision))
+
+    def determine_package_version(self, directory):
+        enterprise_version = self.enterprise_version
+        return self.track.version_template % locals()
+
+    def create_l10n_de_tarball(self, pkgbasedir, pkgbaseversion):
+        logging.info("Creating kde-l10n-de tarball")
+        de_tarball = os.path.join(self.work_dir,
+                                  "kde-l10n-de-" + pkgbaseversion + ".tar.bz2")
+        # xutils-dev is needed for the revpath script used by
+        # scripts/autogen.sh
+        script = (self.createtarball_script
+                  % dict(builddeps="xutils-dev",  tarball=de_tarball,
+                         basedir=pkgbasedir, version=pkgbaseversion))
+        script_name = os.path.join(self.work_dir, "createtarball")
+        treepkg.util.writefile(script_name, script, 0755)
+        treepkg.util.ensure_directory(self.src_dir)
+        treepkg.util.ensure_directory(self.log_dir)
+        self.track.builder.run_script([script_name],
+                                      logfile=os.path.join(self.log_dir,
+                                                           "tarball_log.txt"),
+                                      bindmounts=[self.work_dir])
+        return de_tarball
+
+    def prepare_sources_for_tarball(self, pkgbasedir, pkgbaseversion):
+        de_tarball = self.create_l10n_de_tarball(pkgbasedir, pkgbaseversion)
+        shutil.rmtree(pkgbasedir)
+        os.mkdir(pkgbasedir)
+        os.rename(de_tarball,
+                  os.path.join(pkgbasedir, os.path.basename(de_tarball)))
+
+
+class RevisionPackager(tags.RevisionPackager):
+
+    source_packager_cls = SourcePackager
+
+
+class PackageTrack(tags.PackageTrack):
+
+    revision_packager_cls = RevisionPackager



More information about the Treepkg-commits mailing list